#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/select.h>
#include <sys/socket.h>

#include "greprotocol.h"
#include "reorderer.h"

using namespace std;

in6_addr get_addr(const char *str) {
	in6_addr ret;
	if (inet_pton(AF_INET6, str, &ret) != 1) {
		fprintf(stderr, "Could not parse %s\n", str);
		exit(1);
	}
	return ret;
}

int main(int argc, char **argv)
{
	in6_addr addr_a = get_addr(argv[1]);
	in6_addr addr_b = get_addr(argv[2]);
	in6_addr myaddr = get_addr(argv[3]);
	GREProtocol gre_a(myaddr, addr_a);
	GREProtocol gre_b(myaddr, addr_b);
	Reorderer dst_a(&gre_a);
	Reorderer dst_b(&gre_b);

	fd_set fds;
	FD_ZERO(&fds);
	for ( ;; ) {
		FD_SET(gre_a.fd(), &fds);
		FD_SET(gre_b.fd(), &fds);
		int ret = select(1024, &fds, NULL, NULL, NULL);
		if (ret == -1) {
			perror("select");
			continue;
		}

		if (FD_ISSET(gre_a.fd(), &fds)) {
			gre_a.read_packet(&dst_b);
		}
		if (FD_ISSET(gre_b.fd(), &fds)) {
			gre_b.read_packet(&dst_a);
		}
	}
}
