#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/select.h>
#include <sys/socket.h>

#include "greprotocol.h"
#include "reorderer.h"
#include "tunprotocol.h"

using namespace std;

in6_addr get_addr(const char *str) {
	in6_addr ret;
	if (inet_pton(AF_INET6, str, &ret) != 1) {
		fprintf(stderr, "Could not parse %s\n", str);
		exit(1);
	}
	return ret;
}

int main(int argc, char **argv)
{
	in6_addr myaddr = get_addr(argv[1]);
	in6_addr remoteaddr = get_addr(argv[2]);
	GREProtocol gre(myaddr, remoteaddr);
	TUNProtocol tun("tungre");

	Reorderer tun_reorderer(&tun);

	fd_set fds;
	FD_ZERO(&fds);
	for ( ;; ) {
		FD_SET(gre.fd(), &fds);
		FD_SET(tun.fd(), &fds);
		int ret = select(1024, &fds, NULL, NULL, NULL);
		if (ret == -1) {
			perror("select");
			continue;
		}

		if (FD_ISSET(gre.fd(), &fds)) {
			gre.read_packet(&tun_reorderer);
		}
		if (FD_ISSET(tun.fd(), &fds)) {
			tun.read_packet(&gre);
		}
	}
}
